package supermarketcheckoutsystem;

import java.util.ArrayList;

public class Account {
	
    private int accountNumber;
    private double balance;
    private ArrayList<Card> cardList;

    private static int currentAccountNumber = 0;
    
    public Account(double initialBalance) {
        this.accountNumber = currentAccountNumber;
        this.balance = initialBalance;
        this.cardList = new ArrayList<Card>();
        currentAccountNumber += 1;
    }

    public void updateBalance(double amount) {
        balance += amount;  
    }
    
    public double getBalance() {
        return balance;
    }
    
    public int getAccountNumber() {
		return accountNumber;
	}
    
    public void addCard(Card card) {
    	if(!cardList.contains(card)) {
    		card.setAccountNumber(this.accountNumber);
    		this.cardList.add(card);
    	}
    }
}