package supermarketcheckoutsystem;

import java.util.ArrayList;

public class Bank {
	
	private ArrayList<Account> accounts;
	
	public Bank() {
		accounts = new ArrayList<>();
	}
	
	public void addAccount(Account account) {
		this.accounts.add(account);
	}

	public boolean checkBalance(int accountNumber, double amount) {
        Account account = findAccount(accountNumber);
        return account != null && account.getBalance() >= amount;
    }

    public boolean updateBalance(int accountNumber, double amount) {
        Account account = findAccount(accountNumber);
        if (account != null) {
            account.updateBalance(amount);
            return true;
        }
        return false;
    }

    public boolean accountExists(int accountNumber) {
        return findAccount(accountNumber) != null;
    }

    // Méthode privée pour rechercher un compte
    private Account findAccount(int accountNumber) {
        for (Account acc : accounts) {
            if (acc.getAccountNumber() == accountNumber) {
                return acc;
            }
        }
        return null; // Retourne null si le compte n'existe pas
    }
}
