package supermarketcheckoutsystem;

import java.util.HashMap;
import java.util.Map;

public class CashRegister {

	private POS pos;
	
	public CashRegister(POS pos) {
		this.pos = pos;
	}
	
	public void customerCheckout(Customer customer, boolean receipt, boolean delivery) {
	    Map<Item, Double> currentPurchase = customer.getCurrentPurchase();
	    double price = 0;
	    double weight = 0;
	    System.out.println("\n=== Checkout Process ===");
	    for (Item item : currentPurchase.keySet()) {
	    	double itemAmount = currentPurchase.get(item);
	    	price += item.price * itemAmount * (1-item.pricingPolicy);
	    	weight += item.weight * itemAmount;
	        System.out.println(itemAmount + "*" + item.name + " --- " + itemAmount +"*" + item.price +"€");
	    }
	    price = price * (1-customer.getCustomerPlan().discount);
	    if(delivery) {
	    	price = price + weight*Math.floor(customer.getDeliveryDistance())*(1-customer.getCustomerPlan().deliveryDiscount);
	    	System.out.println("Total price: " + price);
	    	pos.processTransaction(customer, price, receipt);
	    } else {
		    System.out.println("Total price: " + price);
		    pos.processTransaction(customer, price, receipt);
	    }
	    customer.setCurrentPurchase(new HashMap<>());
	}
}
