package supermarketcheckoutsystem;

import java.util.HashMap;
import java.util.Map;


public class Customer {
	public String firstName;
	public String lastName;
	private int deliveryDistance;
	private int id;
	private DiscountPlan customerPlan;
	private Map<Item, Double> currentPurchase;
	private Card card;
	private int rememberedPin;
	
	public Customer(String firstName, String lastName, int deliveryDistance, int id, DiscountPlan customerPlan, Card card,int rememberedPin) {
		this.firstName = firstName;
		this.lastName = lastName;
		this.deliveryDistance = deliveryDistance;
		this.id = id;
		this.customerPlan = customerPlan;
		this.currentPurchase = new HashMap<>();
		this.card = card;
		this.rememberedPin = rememberedPin;
	}

	public int getDeliveryDistance() {
		return deliveryDistance;
	}

	public void setDeliveryDistance(int deliveryDistance) {
		this.deliveryDistance = deliveryDistance;
	}

	public DiscountPlan getCustomerPlan() {
		return customerPlan;
	}

	public void setCustomerPlan(DiscountPlan customerPlan) {
		this.customerPlan = customerPlan;
	}

	public Map<Item, Double> getCurrentPurchase() {
		return currentPurchase;
	}

	public void setCurrentPurchase(Map<Item, Double> currentPurchase) {
		this.currentPurchase = currentPurchase;
	}
	
	public void addItemtoPurchase(Item item,double amount){
		if(currentPurchase.get(item) != null) {
			currentPurchase.put(item, currentPurchase.get(item)+amount);
		} else {
			currentPurchase.put(item, amount);
		}
	}

	public int getId() {
		return id;
	}
	
	public Card getCard() {
		return card;
	}
	
	public int getRememberedPin() {
		return rememberedPin;
	}

}