package supermarketcheckoutsystem;

public class DiscountPlan {

	public String name;
	public double discount;
	public double deliveryDiscount;
	public double price;
	
	public DiscountPlan(String name, double discount, double deliveryDiscount, double price) throws Exception {
		super();
		this.name = name;
		if(discount < 0 || discount>1) {
			throw new Exception("A discount must between 0 and 1.");
		}
		this.discount = discount;
		if(deliveryDiscount <0 || deliveryDiscount >1) {
			throw new Exception("A delivery discount must between 0 and 1.");
		}
		this.deliveryDiscount = deliveryDiscount;
		if(price <0) {
			throw new Exception("Discount price must be positive.");
		}
		this.price = price;
	}

	public void setDiscount(double discount) throws Exception {
		if(discount < 0 || discount>1) {
			throw new Exception("A discount must between 0 and 1.");
		}
		this.discount = discount;
	}

	public void setDeliveryDiscount(double deliveryDiscount) throws Exception {
		if(deliveryDiscount <0) {
			throw new Exception("A delivery discount must between 0 and 1.");
		}
		this.deliveryDiscount = deliveryDiscount;
	}

	public void setPrice(double price) throws Exception {
		if(price <0) {
			throw new Exception("Discount price must be positive.");
		}
		this.price = price;
	}
}
