package supermarketcheckoutsystem;

enum Category{Vegetables, Other}

public class Item {

	public String name;
	public double price;
	public double weight;
	public double pricingPolicy;
	public int id;
	public Category category;
	
	public Item(String name, double price, double weight, double pricingPolicy, int id, Category category) throws Exception {
		super();
		this.name = name;
		if(price <0) {
			throw new Exception("Item price must be positive.");
		}
		this.price = price;
		this.weight = weight;
		if(weight <0) {
			throw new Exception("Item weight must be positive.");
		}
		if(pricingPolicy <0 || pricingPolicy >1) {
			throw new Exception("A pricingPolicy must between 0 and 1.");
		}
		this.pricingPolicy = pricingPolicy;
		this.id = id;
		this.category = category;
	}

	public void setPrice(double price) throws Exception {
		if(price <0) {
			throw new Exception("Item price must be positive.");
		}
		this.price = price;
	}

	public void setWeight(double weight) throws Exception {
		if(weight <0) {
			throw new Exception("Item weight must be positive.");
		}
		this.weight = weight;
	}

	public void setPricingPolicy(double pricingPolicy) throws Exception {
		if(pricingPolicy <0 || pricingPolicy >1) {
			throw new Exception("A pricingPolicy must between 0 and 1.");
		}
		this.pricingPolicy = pricingPolicy;
	}
	
}
