package supermarketcheckoutsystem;

public class Main {
    public static void main(String[] args) {
        try {
            // Création de la banque et du TAS
            Bank bank = new Bank();
            TAS tas = new TAS(bank);

            // Création d'un compte et d'une carte
            Account customerAccount = new Account(500); // Solde initial : 500€
            Account supermarketAccount = new Account(0); // Solde initial : 500€
            bank.addAccount(customerAccount);
            bank.addAccount(supermarketAccount);
            Card customerCard = new Card(1234);
            customerAccount.addCard(customerCard);

            // Création du POS et de la caisse
            POS pos = new POS(tas, supermarketAccount.getAccountNumber());
            CashRegister cashRegister = new CashRegister(pos);

            // Création du supermarché
            Supermarket supermarket = new Supermarket(cashRegister);

            // Création et ajout des articles en stock
            Item apple = new Item("Apple", 1.5, 0.2, 0.1, 1, Category.Vegetables);
            Item bread = new Item("Bread", 2.0, 0.5, 0.05, 2, Category.Other);
            supermarket.addToInventory(apple);
            supermarket.addToInventory(bread);

            // Création d'un plan de réduction et d'un client
            Customer customer = new Customer("John", "Doe", 5, 1, supermarket.discounts.get("prime"), customerCard, 1234);
            supermarket.addCustomer(customer);

            // Ajout d'articles à l'achat du client
            supermarket.addItemToCustomer(customer, apple, 3); // 3 pommes
            supermarket.addItemToCustomer(customer, bread, 2); // 2 pains

            // Passage en caisse
            supermarket.customerCheckout(customer, true, false); // Avec reçu, sans livraison

            System.out.println(" Account Balance after this test ");
            System.out.println("customerAccount: " + customerAccount.getBalance() +"€");
            System.out.println("supermarketAccount: " + supermarketAccount.getBalance()+"€");
            
            
        } catch (Exception e) {
            System.out.println("Erreur : " + e.getMessage());
        }
    }
}