package supermarketcheckoutsystem;

class POS {
    private TAS tas;
    
    private int supermarketAccountNumber;
    
    public POS(TAS tas, int supermarketAccountNumber) throws Exception{
        this.tas = tas;
        if (tas.accountExists(supermarketAccountNumber)) {
        	this.supermarketAccountNumber = supermarketAccountNumber;
        } else {
        	throw new Exception("Account number does not exist.");
        }
    }

    // Card verification
    private boolean verifyCard(Card card) {
    	return tas.accountExists(card.getAccountNumber());
    }
    
    public boolean verifyPin(Card card, Customer customer) {
        return card.checkPin(customer.getRememberedPin());
    }

    // Print receipt
    private void printReceipt(int cardNumber, double transactionAmount) {
        System.out.println("\n===== RECEIPT =====");
        System.out.println("Card Number: " + cardNumber);
        System.out.println("Transaction Amount: " + transactionAmount + "€");
        System.out.println("===================");
    }
    
    public boolean processTransaction(Customer customer, double amount, boolean receipt) {

    	Card card = customer.getCard();
        if (!verifyCard(card)) {
            System.out.println("Card is not valid. Transaction denied.");
            return false;
        }
        System.out.println("Card is valid.");

        if (!verifyPin(card, customer)) {
            System.out.println("Incorrect PIN. Transaction denied.");
            return false;
        }
        System.out.println("Correct PIN.");
        
        if(!tas.processTransaction(card.getAccountNumber(),supermarketAccountNumber, amount)) {
        	System.out.println("Transaction canceled.");
        	return false;
        }
       
        if(receipt) {
        	printReceipt(card.getCardNumber(), amount);
        }
        return true;
    }
}
