package supermarketcheckoutsystem;

class TAS {
    
	private Bank bank;
	private boolean SecureConnectionOpen = false;
	
    public TAS(Bank bank) {
        this.bank = bank;
    }
    
    public boolean accountExists(int accountNumber) {
    	return bank.accountExists(accountNumber);
    }
    
    public boolean authorisation(int accountNumber, double amount) {
    	return bank.checkBalance(accountNumber, amount);
    }
    
    public void updateBalance(int accountNumber, double amount) {
    	bank.updateBalance(accountNumber, amount);
    }
    
    public boolean openSecureConnection() {
    	if (!SecureConnectionOpen) {
    		SecureConnectionOpen = true;
    		return true;
    	} else {
    		return false;
    	}
    }
    
    public boolean closeSecureConnection() {
    	if (SecureConnectionOpen) {
    		SecureConnectionOpen = false;
    		return true;
    	} else {

    		return false;
    	}
    }
    
    public boolean processTransaction(int clientnumber, int supermarketnumber, double amount) {
    	
    	if(!openSecureConnection()) {
    		System.out.println("Already opened");
    		closeSecureConnection();
    		return false;
    	}
    	
    	if (!authorisation(clientnumber, amount)) {
    		System.out.println("Authorisation denied.");
    		closeSecureConnection();
            return false;
    	}
    	System.out.println("Authorisation accepted.");
    	
    	updateBalance(clientnumber, -amount);
    	updateBalance(supermarketnumber, +amount);
    	
    	if(!closeSecureConnection()) {
    		System.out.println("Already closed");
    		return false;
    	}
    	
    	return true;
    }
}